#####################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../standard.4gs/fg_bname.4gl  1.1  Last Delta: 5/15/90
#####################################################################


#####################################################################
function fg_basename(file_name)
# returns parent and base names
#####################################################################
# This function determines the basename and parent directory for the
# given file name. It returns the substrings delineated by the last
# '/' in the file name. If there are no '/' in the file name the
# parent will be null.
#
    define
        file_name   char(200),
        base_name   char(200),
        parent_name char(200),
        name_len    smallint,
        n           smallint

    # initialize
    let name_len = length(file_name)

    # make sure file_name is not null
    if name_len < 1
    then
        return "", ""
    end if

    # find the last '/' in the file name
    for n = name_len to 1 step -1
        if file_name[n] = "/"
        then
            exit for
        end if
    end for

    # test for no '/' in file name or '/' at beginning
    if n = 1
    then
        if file_name[1] != "/"
        then
            let base_name = file_name
        else
            let base_name = file_name[2, name_len]
        end if
        let parent_name = ""

    # test for file name ending in '/' or normal name
    else
        # ends in '/'
        if n = name_len
        then
            let base_name = ""
            let parent_name = file_name[1, n - 1]

        # normal file name
        else
            let base_name = file_name[n + 1, name_len]
            let parent_name = file_name[1, n - 1]
        end if
    end if

    # return the base name and parent directory name
    return base_name, parent_name

end function
# end fg_basename()
